/*
やぁ、よくきたね。ようこそ魅魔Q解析補助ツールスクリプトへ。
このスパゲティスクリプトはサービスなので、まずは落ち着いて召し上がってほしい。
*/

if(!mimaq) var mimaq = {};

var mimaqObserverService;
var mimaqItemStore;
var mimaqItemStoreCha1;
var mimaqItemStoreCha2;
var mimaqItemStoreCha3;
var mimaqColorChange;
var console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);



var mimaqObserver = {
    observe: function (aSubject, aTopic, aState) {
        if(aTopic == "http-on-modify-request"){
        	channel = aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
        	channel = channel.QueryInterface(Components.interfaces.nsIUploadChannel);
        	channel = channel.uploadStream;
        	channel.QueryInterface(Components.interfaces.nsISeekableStream).seek(Components.interfaces.nsISeekableStream.NS_SEEK_SET, 0);
        	var stream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
        	stream.setInputStream(channel);
        	var postBytes = stream.readByteArray(stream.available());
        	poststr = String.fromCharCode.apply(null, postBytes);
        	
        	try{
        		var reqNum = poststr.indexOf("ix",0);
        		
        		if(reqNum > 0){
        			document.getElementById('globalBtnUpdate').disabled = false;
        			
        			var d  = new Date();
        			
        			var year  = d.getFullYear();
        			var month = d.getMonth()+1;
        			var day   = d.getDate();
        			var hour  = d.getHours();
        			var min   = d.getMinutes();
        			var sec   = d.getSeconds();
        			
        			var nowDate = hour+'時'+min+'分'+sec+'秒';
        			
        			document.getElementById('globalLabelData').value = nowDate + " のデータ受信！";
        			
        			var reqStr = poststr.slice(reqNum);
        			
        			document.getElementById('infowindow').value = reqStr.replace(/&/g,"\n");
        			document.getElementById('infowindow2').value = poststr.replace(/&/g,"\n");
        			
        			var test;
        			test = mimaq.dataget("invent",reqStr);
        			test = mimaq.dataget("cha1",reqStr);
        			test = mimaq.dataget("cha2",reqStr);
        			test = mimaq.dataget("cha3",reqStr);
        			
        			var depthStartNum = reqStr.indexOf("dta130",0);
        			var depthEndNum = reqStr.indexOf("dta131",0);
        			if(depthStartNum > 0){
        				var depthNum = reqStr.slice(depthStartNum,depthEndNum-1);
        				depthNum = depthNum.split('=');
        				document.getElementById('cha1lv').value = depthNum[1];
        				document.getElementById('cha2lv').value = depthNum[1];
        				document.getElementById('cha3lv').value = depthNum[1];
        				document.getElementById('depthtextbox').value = depthNum[1];
        			}
        			
        		}else{
        			document.getElementById('infowindow2').value = poststr.replace(/&/g,"\n");
        		}
        	}catch(e){
        		//error
        	}
        	
        	var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
        	stringStream.setData(poststr, poststr.length);
        	channel = aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
        	channel = channel.uploadStream;
        	channel = channel.QueryInterface(Components.interfaces.nsISeekableStream).seek(Components.interfaces.nsISeekableStream.NS_SEEK_SET, 0);
        	channel.uploadStream.QueryInterface(Components.interfaces.nsIMIMEInputStream);
        	channel.uploadStream.setData(stringStream);
        	channel.requestMethod = "POST";
        	channel.send();
        }

    }
};


mimaq = {
	traceToggle: function(o){
		if(o == "on"){
			document.getElementById('globalBtnTraceStart').disabled = true;
			document.getElementById('globalBarStop').style.display = "none";
			document.getElementById('globalBarStart').style.display = "block";
			document.getElementById('globalLabelState').value = "通信内容監視中...";
		}else if(o == "off"){
			document.getElementById('globalBtnTraceStart').disabled = false;
			document.getElementById('globalBarStop').style.display = "block";
			document.getElementById('globalBarStart').style.display = "none";
			document.getElementById('globalLabelState').value = "動作停止...　　　";
		}
	},
	unregObs: function(){
		mimaqObserverService.removeObserver(mimaqObserver,"http-on-modify-request");
		mimaq.traceToggle("off");
	},
	regObs: function(){
		mimaqObserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		mimaqObserverService.addObserver(mimaqObserver, "http-on-modify-request", false);
		mimaq.traceToggle("on");
	},
	dataget: function(dataflag,reqStr){
	try{
	
		if(dataflag == "invent"){
		mimaqItemStore = new Array();
			var dataflagItemStartNum = "dta19";
			var dataflagItemEndNum = "dta70";
			var dataflagItemStrenStartNum = "dta69";
			var dataflagItemStrenEndNum = "dta119";
		}else if(dataflag == "cha1"){
		mimaqItemStoreCha1 = new Array();
			var dataflagItemStartNum = "dta7";
			var dataflagItemEndNum = "dta10";
			var dataflagItemStrenStartNum = "dta119";
			var dataflagItemStrenEndNum = "dta122";
		}else if(dataflag == "cha2"){
		mimaqItemStoreCha2 = new Array();
			var dataflagItemStartNum = "dta10";
			var dataflagItemEndNum = "dta13";
			var dataflagItemStrenStartNum = "dta122";
			var dataflagItemStrenEndNum = "dta125";
		}else if(dataflag == "cha3"){
		mimaqItemStoreCha3 = new Array();
			var dataflagItemStartNum = "dta13";
			var dataflagItemEndNum = "dta16";
			var dataflagItemStrenStartNum = "dta125";
			var dataflagItemStrenEndNum = "dta128";
		}
		
		var itemStartStrNum = reqStr.indexOf(dataflagItemStartNum,0);
        var itemEndStrNum = reqStr.indexOf(dataflagItemEndNum,0);
        var itemStr = reqStr.substring(itemStartStrNum,itemEndStrNum-1);//アイテムIDのデータ取り出し
        var itemStrArr = itemStr.split("&");//アイテムID分割
        
        var itemStrenStartNum = reqStr.indexOf(dataflagItemStrenStartNum,0);
        var itemStrenEndNum = reqStr.indexOf(dataflagItemStrenEndNum,0);
        var itemStren = reqStr.substring(itemStrenStartNum,itemStrenEndNum-1);
        var itemStrenArr = itemStren.split("&");
        for(i=0;i<itemStrArr.length;i++){
        	var itemStockArr = itemStrArr[i].split("=");
        	var itemStockStrenArr = itemStrenArr[i].split("=");
        	
			var itemStockArrNum = itemStockArr[1].length;
			if(itemStockArrNum == 9){
				var itemIdStartNum = 7;
			}else if(itemStockArrNum == 8){
				var itemIdStartNum = 6;
			}else if(itemStockArrNum == 7){
				var itemIdStartNum = 5;
			}else if(itemStockArrNum == 6){
				var itemIdStartNum = 4;
			}else if(itemStockArrNum == 3){
				var itemIdStartNum = 1;
			}else if(itemStockArrNum == 1){
				var itemIdStartNum = -1;
			}else{
				var itemIdStartNum = -1;
			}
			
        	var itemStrenIdEndNum = itemStockStrenArr[1].lastIndexOf("000");
        	var strenID = 0;
        	if(itemStrenIdEndNum > 0){
        		strenID = itemStockStrenArr[1].slice(0,itemStrenIdEndNum);
        	}else{
        		
        		//super zantei code
        		if(itemStockStrenArr[1].length == 6){
        			var lastNumCheck = itemStockStrenArr[1].slice(3,6);
        			if(lastNumCheck == 100){
        				strenID = itemStockStrenArr[1].slice(0,3);
        			}else{
        				strenID = 0;
        			}
        		}else if(itemStockStrenArr[1].length == 7){
        			var lastNumCheck = itemStockStrenArr[1].slice(4,7);
        			if(lastNumCheck == 100){
        				strenID = itemStockStrenArr[1].slice(0,4);
        			}else{
        				strenID = 0;
        			}
        		}else if(itemStockStrenArr[1].length == 8){
        			var lastNumCheck = itemStockStrenArr[1].slice(5,8);
        			if(lastNumCheck == 100){
        				strenID = itemStockStrenArr[1].slice(0,5);
        			}else{
        				strenID = 0;
        			}
        		}else{
        			strenID = 0;
        		}
        	}
        	
        	var wordID = 0;
        	var itemID = 0;
        	if(itemIdStartNum == 7){
        		wordID = itemStockArr[1].slice(0,4);
        		itemID = itemStockArr[1].slice(itemIdStartNum-1,9);
        	}else if(itemIdStartNum == 6){
        		wordID = itemStockArr[1].slice(0,3);
        		itemID = itemStockArr[1].slice(itemIdStartNum-1,8);
        	}else if(itemIdStartNum == 5){
        		wordID = itemStockArr[1].slice(0,2);
        		itemID = itemStockArr[1].slice(itemIdStartNum-1,7);
        	}else if(itemIdStartNum == 4){
        		wordID = itemStockArr[1].slice(0,1);
        		itemID = itemStockArr[1].slice(itemIdStartNum-1,6);
        	}else if(itemIdStartNum == 3){
        		//wordID = 0;
        		itemID = itemStockArr[1];
        	}else{
        		//wordID = 0;
        		itemID = itemStockArr[1];
        	}
        	
        	moveDB(itemID,wordID,strenID,dataflag);
        	
        }
        
    }catch(e){
    	//console.logStringMessage(e);
    }

	},
	chara: function(num){
		switch(num){
			case 2:return("ルーミア");break;
			default:return("不明");break;
		}
	},
	chastate: function(chaEq,who){
	
		//数値化忘れずに。
		chaEq0 = new Number(chaEq[0]);
		chaEq1 = new Number(chaEq[1]);
		if(chaEq[4] == 0){ chaEq4 = 1;}else{ chaEq4 = chaEq[4]/100; }//head hp
		if(chaEq[5] == 0){ chaEq5 = 1;}else{ chaEq5 = chaEq[5]/100; }//head str
		if(chaEq[6] == 0){ chaEq6 = 1;}else{ chaEq6 = chaEq[6]/100; }//head vit
		if(chaEq[7] == 0){ chaEq7 = 1;}else{ chaEq7 = chaEq[7]/100; }//head dex
		if(chaEq[8] == 0){ chaEq8 = 1;}else{ chaEq8 = chaEq[8]/100; }//head agi
		if(chaEq[9] <= 0){ chaEq9 = 1;}else if(chaEq[9] > 0){ chaEq9 = chaEq[9]/100/*stack*/ }else{ chaEq9 = 1;}//head atk
		if(chaEq[10] <= 0){ chaEq10 = 1;}else if(chaEq[10] > 0){ chaEq10 = chaEq[10]/100/*stack*/ }else{ chaEq10 = 1;}//head def
		if(chaEq[12] == 0){ chaEq12 = 1;}else{ chaEq12 = chaEq[12]/100; }//str
		if(chaEq[13] == 0){ chaEq13 = 1;}else{ chaEq13 = chaEq[13]/100; }//vit
		if(chaEq[14] == 0){ chaEq14 = 1;}else{ chaEq14 = chaEq[14]/100; }//dex
		if(chaEq[15] == 0){ chaEq15 = 1;}else{ chaEq15 = chaEq[15]/100; }//agi
		if(chaEq[17] == 0){ chaEq17 = 1;}else{ chaEq17 = chaEq[17]/100; }//atk
		if(chaEq[18] == 0){ chaEq18 = 1;}else{ chaEq18 = chaEq[18]/100; }//def
		var chaLv = document.getElementById('cha'+who+'lv').value;//cha lv
		var chaBase = chaLv * 3;
		
		var str = Math.floor((( chaEq0 + chaEq1 + 20 ) * chaEq12 * chaEq5 - 100) / 100 * chaLv);
		var dex = Math.floor((( chaEq0 + chaEq1 + 20 ) * chaEq14 * chaEq7 - 100) / 100 * chaLv);
		var vit = Math.floor((( chaEq0 + chaEq1 + 20 ) * chaEq13 * chaEq6 - 100) / 100 * chaLv);
		var agi = Math.floor((( chaEq0 + chaEq1 + 20 ) * chaEq15 * chaEq8 - 100) / 100 * chaLv);
		var atk = chaEq17;
		var def = chaEq18;
		var headhp = chaEq4;
		var headstr = chaEq5;
		var headdex = chaEq7;
		var headvit = chaEq6;
		var headagi = chaEq8;
		var headatk = chaEq9;
		var headdef = chaEq10;
		var res = [who,str,dex,vit,agi,atk,def,headstr,headdex,headvit,headagi,headatk,headdef,chaBase];
		return res;
	},
	chatotal: function(chaEq,who){
		var cha1 = mimaq.chastate(chaEq[0],who);
		var cha2 = mimaq.chastate(chaEq[1],who);
		var cha3 = mimaq.chastate(chaEq[2],who);
		var str = (cha1[1]*cha1[7])+(cha2[1]*cha2[7])+(cha3[1]*cha3[7]) + cha1[13];//str total  接頭の倍率を各々入れる
		var dex = (cha1[2]*cha1[8])+(cha2[2]*cha2[8])+(cha3[2]*cha3[8]) + cha1[13];//dex total
		var vit = (cha1[3]*cha1[9])+(cha2[3]*cha2[9])+(cha3[3]*cha3[9]) + cha1[13];//vit total
		var agi = (cha1[4]*cha1[10])+(cha2[4]*cha2[10])+(cha3[4]*cha3[10]) + cha1[13];//agi total
		
		if(str > dex){
			var atk = Math.round((((str+dex)/2)+dex)*(cha1[11]*cha2[11]*cha3[11]));
		}else{
			var atk = Math.round((((str+dex)/2)+str)*(cha1[11]*cha2[11]*cha3[11]));
		}
		if(vit > agi){
			var def = Math.round((((vit+agi)/2)+agi)*(cha1[12]*cha2[12]*cha3[12]));
		}else{
			var def = Math.round((((vit+agi)/2)+vit)*(cha1[12]*cha2[12]*cha3[12]));
		}
		
		var res = [str,dex,vit,agi,atk,def];
		return res;
		
		
	},
	chainsert: function(){
	
		var ins1 = mimaq.chatotal(simCha1Data,1);
		document.getElementById('cha1str').value = ins1[0];
		document.getElementById('cha1dex').value = ins1[1];
		document.getElementById('cha1vit').value = ins1[2];
		document.getElementById('cha1agi').value = ins1[3];
		document.getElementById('cha1atk').value = ins1[4];
		document.getElementById('cha1def').value = ins1[5];
		
		var ins2 = mimaq.chatotal(simCha2Data,2);
		document.getElementById('cha2str').value = ins2[0];
		document.getElementById('cha2dex').value = ins2[1];
		document.getElementById('cha2vit').value = ins2[2];
		document.getElementById('cha2agi').value = ins2[3];
		document.getElementById('cha2atk').value = ins2[4];
		document.getElementById('cha2def').value = ins2[5];
		
		var ins3 = mimaq.chatotal(simCha3Data,3);
		document.getElementById('cha3str').value = ins3[0];
		document.getElementById('cha3dex').value = ins3[1];
		document.getElementById('cha3vit').value = ins3[2];
		document.getElementById('cha3agi').value = ins3[3];
		document.getElementById('cha3atk').value = ins3[4];
		document.getElementById('cha3def').value = ins3[5];
		
		
		//階層計算　必要ATK/DEF
		var depthAtk = document.getElementById('depthtextbox').value;
		var depthDef = document.getElementById('depthtextbox').value;
		depthAtk = Math.round(depthAtk * depthAtk);
		depthDef = Math.round(depthDef * depthDef * 0.15);
		document.getElementById('mustatk').value = depthAtk;
		document.getElementById('mustdef').value = depthDef;
		
		//パリン計算
		var cha1atk = document.getElementById('cha1atk').value;
		var cha1def = document.getElementById('cha1def').value;
		var cha1holdatk = Math.round((cha1atk/depthAtk)*100);
		var cha1holddef = Math.round((cha1def/depthDef)*100);
		document.getElementById('cha1mustatkmet').value = cha1holdatk;
		document.getElementById('cha1mustdefmet').value = cha1holddef;
		document.getElementById('cha1mustatkcomment').value = "ATK：" + cha1holdatk + "%";
		document.getElementById('cha1mustdefcomment').value = "DEF：" + cha1holddef + "%";
		
		var cha2atk = document.getElementById('cha2atk').value;
		var cha2def = document.getElementById('cha2def').value;
		var cha2holdatk = Math.round((cha2atk/depthAtk)*100);
		var cha2holddef = Math.round((cha2def/depthDef)*100);
		document.getElementById('cha2mustatkmet').value = cha2holdatk;
		document.getElementById('cha2mustdefmet').value = cha2holddef;
		document.getElementById('cha2mustatkcomment').value = "ATK：" + cha2holdatk + "%";
		document.getElementById('cha2mustdefcomment').value = "DEF：" + cha2holddef + "%";
		
		var cha3atk = document.getElementById('cha3atk').value;
		var cha3def = document.getElementById('cha3def').value;
		var cha3holdatk = Math.round((cha3atk/depthAtk)*100);
		var cha3holddef = Math.round((cha3def/depthDef)*100);
		document.getElementById('cha3mustatkmet').value = cha3holdatk;
		document.getElementById('cha3mustdefmet').value = cha3holddef;
		document.getElementById('cha3mustatkcomment').value = "ATK：" + cha3holdatk + "%";
		document.getElementById('cha3mustdefcomment').value = "DEF：" + cha3holddef + "%";
		
	},
	displayDepth: function(e){
		var Ci = Components.interfaces;
		var XULWindow = window
		    .QueryInterface(Ci.nsIInterfaceRequestor)
		    .getInterface(Ci.nsIWebNavigation)
		    .QueryInterface(Ci.nsIDocShellTreeItem)
		    .treeOwner
		    .QueryInterface(Ci.nsIInterfaceRequestor)
		    .getInterface(Ci.nsIXULWindow);
		if(e.checked == true){
			XULWindow.zLevel = Ci.nsIXULWindow.raisedZ;
		}else{
			XULWindow.zLevel = Ci.nsIXULWindow.normalZ;
		}
	},
	manualSim: function(who,mustatk,mustdef){
		//var lv = document.getElementById('manu-cha'+who+'lv').value;
		var str = new Number(document.getElementById('manu-cha'+who+'str').value);
		var dex = new Number(document.getElementById('manu-cha'+who+'dex').value);
		var vit = new Number(document.getElementById('manu-cha'+who+'vit').value);
		var agi = new Number(document.getElementById('manu-cha'+who+'agi').value);
		
		if(str > dex){
			var atk = Math.round(((str+dex)/2)+dex);
		}else{
			var atk = Math.round(((str+dex)/2)+str);
		}
		if(vit > agi){
			var def = Math.round(((vit+agi)/2)+agi);
		}else{
			var def = Math.round(((vit+agi)/2)+vit);
		}
		
		var atkbonus = new Number(document.getElementById('manu-cha'+who+'atkbonus').value)/100;
		var defbonus = new Number(document.getElementById('manu-cha'+who+'defbonus').value)/100;
		atk = Math.round(atk * atkbonus);
		def = Math.round(def * defbonus);
		
		document.getElementById('manu-cha'+who+'atk').value = atk;
		document.getElementById('manu-cha'+who+'def').value = def;
		
		var holdatk = Math.round((atk/mustatk)*100);
		var holddef = Math.round((def/mustdef)*100);
		document.getElementById('manu-cha'+who+'mustatkmet').value = holdatk;
		document.getElementById('manu-cha'+who+'mustdefmet').value = holddef;
		document.getElementById('manu-cha'+who+'mustatkcomment').value = "ATK：" + holdatk + "%";
		document.getElementById('manu-cha'+who+'mustdefcomment').value = "DEF：" + holddef + "%";
		
	},
	manualSimStart: function(){
		var depth = new Number(document.getElementById('manu-depthtextbox').value);
		var mustatk = Math.round(depth * depth);
		var mustdef = Math.round(depth * depth * 0.15);
		document.getElementById('manu-mustatk').value = mustatk;
		document.getElementById('manu-mustdef').value = mustdef;
		
		var test;
		test = mimaq.manualSim(1,mustatk,mustdef);
		test = mimaq.manualSim(2,mustatk,mustdef);
		test = mimaq.manualSim(3,mustatk,mustdef);
		
	},
	fileSave: function(){

	   var nsIFilePicker = Components.interfaces.nsIFilePicker;
	   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	   fp.init(window, "Save File", nsIFilePicker.modeSave);
	   var res = fp.show();
	   if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace){
	     var out = Components.classes['@mozilla.org/network/file-output-stream;1'].
                  createInstance(Components.interfaces.nsIFileOutputStream);
        //var tbox = document.getElementById("edit-area");
        var stack = "";
        for(i=0;i<simData.length;i++){
          stack += simData[i][0]+"\t";
          stack += 0+"\t";
          stack += simData[i][1]+"\t";
          stack += 0+"\t";
          stack += 0+"\t";
          stack += 0+"\t";
          stack += 0+"\t";
          stack += 0+"\t";
          stack += "\n";
        }
         var tbox = stack;
         var thefile = fp.file;
         try {
           out.init(thefile, 0x2a, 0x200, false); // open as "write only"
           out.write(tbox, tbox.length);
           out.close();
         } catch(e) {
           //alert(e);
         }
       }
	},
	colorChange: function(e){
		if(e.checked == true){
			mimaqColorChange = 1;
		}else{
			mimaqColorChange = 0;
		}
	},
	fileSaveItem: function(){
		var stack = "";
		for(i=0;i<simData.length;i++){
			if(simData[i][11] != 0){
				stack += simData[i][11]+"+";
				stack += simData[i][1]+"\n";
			}
        }
        document.getElementById('soitemwindow').value = stack;
        
        var stackcha = "";
        for(i=0;i<simCha1Data.length;i++){
        	if(simCha1Data[i][11] != 0){
				stackcha += simCha1Data[i][11]+"+";
				stackcha += simCha1Data[i][1]+"\n";
			}
        }
        for(i=0;i<simCha2Data.length;i++){
        	if(simCha1Data[i][11] != 0){
				stackcha += simCha2Data[i][11]+"+";
				stackcha += simCha2Data[i][1]+"\n";
			}
        }
        for(i=0;i<simCha3Data.length;i++){
        	if(simCha1Data[i][11] != 0){
				stackcha += simCha3Data[i][11]+"+";
				stackcha += simCha3Data[i][1]+"\n";
			}
        }
        document.getElementById('soitemwindow2').value = stackcha;
        
        var stackhead1 = "";
        for(i=0;i<simData.length;i++){
        	if(simData[i][3].indexOf("○") != -1){
        		stackhead1 += simData[i][3].replace("○○",simData[i][11])+"+"+simData[i][1]+"\n";
        	}else{
				if(simData[i][11] != 0){
					if(simData[i][3] != 0 && simData[i][3] != "※未確認接頭"){
						stackhead1 += simData[i][3];
					}
					stackhead1 += simData[i][11]+"+";
					stackhead1 += simData[i][1]+"\n";
				}
			}
        }
        document.getElementById('soitemwindow3').value = stackhead1;
        
        var stackhead2 = "";
         for(i=0;i<simCha1Data.length;i++){
         	if(simCha1Data[i][3].indexOf("○") != -1){
        		stackhead2 += simCha1Data[i][3].replace("○○",simCha1Data[i][11])+"+"+simCha1Data[i][1]+"\n";
        	}else{
        		if(simCha1Data[i][11] != 0){
        			if(simCha1Data[i][3] != 0 && simCha1Data[i][3] != "※未確認接頭"){
						stackhead2 += simCha1Data[i][3];
					}
					stackhead2 += simCha1Data[i][11]+"+";
					stackhead2 += simCha1Data[i][1]+"\n";
				}
			}
        }
        for(i=0;i<simCha2Data.length;i++){
        	if(simCha2Data[i][3].indexOf("○") != -1){
        		stackhead2 += simCha2Data[i][3].replace("○○",simCha2Data[i][11])+"+"+simCha2Data[i][1]+"\n";
        	}else{
        		if(simCha1Data[i][11] != 0){
        			if(simCha2Data[i][3] != 0 && simCha2Data[i][3] != "※未確認接頭"){
						stackhead2 += simCha2Data[i][3];
					}
					stackhead2 += simCha2Data[i][11]+"+";
					stackhead2 += simCha2Data[i][1]+"\n";
				}
			}
        }
        for(i=0;i<simCha3Data.length;i++){
        	if(simCha3Data[i][3].indexOf("○") != -1){
        		stackhead2 += simCha3Data[i][3].replace("○○",simCha3Data[i][11])+"+"+simCha3Data[i][1]+"\n";
        	}else{
        		if(simCha1Data[i][11] != 0){
        			if(simCha3Data[i][3] != 0 && simCha3Data[i][3] != "※未確認接頭"){
						stackhead2 += simCha3Data[i][3];
					}
					stackhead2 += simCha3Data[i][11]+"+";
					stackhead2 += simCha3Data[i][1]+"\n";
				}
			}
        }
        
        document.getElementById('soitemwindow4').value = stackhead2;
        
	},
};


//Firefox3と4分岐
function moveDB(query,wordID,strenID,dataflag){
const id = "mimaq@frea.in";
   try{
	Components.utils.import("resource://gre/modules/AddonManager.jsm"); 
	var file = "";
	AddonManager.getAddonByID(id, function(addon) {
	  file = addon.getResourceURI("mimaqdb.sqlite").QueryInterface(Components.interfaces.nsIFileURL).file;
	  moveDB2(query,wordID,strenID,dataflag,file);
	});
	//var thread = Components.classes['@mozilla.org/thread-manager;1'].getService().mainThread;
	
   }catch(e){
   	var file = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id);
	file.append("mimaqdb.sqlite");
	moveDB2(query,wordID,strenID,dataflag,file);
   }
}

//内部DBから情報取得
function moveDB2(query,wordID,strenID,dataflag,file){
    
	var storageService = Components.classes["@mozilla.org/storage/service;1"]  
		.getService(Components.interfaces.mozIStorageService);  
	var database = storageService.openDatabase(file);

	var statement = database.createStatement("SELECT * FROM itemdata where itemrank = "+query+"");
	var itemDat = new Array();
	while (statement.executeStep()) {
		var irStack = statement.getString(0);
		itemDat = [statement.getString(0),strenID,wordID,statement.getString(1),statement.getString(2),statement.getString(3),statement.getString(4),statement.getString(5),statement.getString(6),statement.getString(7),statement.getString(8),statement.getString(9),statement.getString(10)];
	}
	if(irStack == undefined){
		itemDat = ["0","0","0","0","0","0","0","0","0","0","0","0","0"];
	}
	if(wordID != 0){
		var wordState = database.createStatement("SELECT * FROM word where wordid = "+wordID+"");
		while (wordState.executeStep()){
			var worddbId = wordState.getString(0);
			var worddbName = wordState.getString(1);
			var worddbHp = wordState.getString(2);
			var worddbStr = wordState.getString(3);
			var worddbVit = wordState.getString(4);
			var worddbDex = wordState.getString(5);
			var worddbAgi = wordState.getString(6);
			if(wordState.getString(7) >= 0){var worddbAtk = Math.round(wordState.getString(7)*10000)/100;}else{var worddbAtk = wordState.getString(7);}
			if(wordState.getString(8) >= 0){var worddbDef = Math.round(wordState.getString(8)*10000)/100;}else{var worddbDef = wordState.getString(8);}
			
			itemDat.splice(3, 0, worddbName, worddbHp, worddbStr, worddbVit, worddbDex, worddbAgi, worddbAtk, worddbDef);
		}
		if(worddbName == undefined){
			itemDat.splice(3,0,"※未確認接頭","0","0","0","0","0","0","0");
		}
	}else{
		itemDat.splice(3,0,"0","0","0","0","0","0","0","0");
	}
	
	if(dataflag == "invent"){
		mimaqItemStore.push(itemDat);
	}else if(dataflag == "cha1"){
		mimaqItemStoreCha1.push(itemDat);
	}else if(dataflag == "cha2"){
		mimaqItemStoreCha2.push(itemDat);
	}else if(dataflag == "cha3"){
		mimaqItemStoreCha3.push(itemDat);
	}

	return true;
}





//ツリー
var gmimaqData;
var gmimaqCha1Data;
var gmimaqCha2Data;
var gmimaqCha3Data;
var gmimaqTreeView = null;
var gmimaqCha1TreeView = null;
var gmimaqCha2TreeView = null;
var gmimaqCha3TreeView = null;
var simData;
var simCha1Data;
var simCha2Data;
var simCha3Data;


function init() {
	document.getElementById('globalBtnUpdate').disabled = true;
	gmimaqData = mimaqItemStore;
	gmimaqCha1Data = mimaqItemStoreCha1;
	gmimaqCha2Data = mimaqItemStoreCha2;
	gmimaqCha3Data = mimaqItemStoreCha3;
	simData = mimaqItemStore;
	simCha1Data = mimaqItemStoreCha1;
	simCha2Data = mimaqItemStoreCha2;
	simCha3Data = mimaqItemStoreCha3;
	gmimaqTreeView = null;
	gmimaqCha1TreeView = null;
	gmimaqCha2TreeView = null;
	gmimaqCha3TreeView = null;
	gmimaqTreeView = new mimaqTreeView(gmimaqData);
	gmimaqCha1TreeView = new mimaqTreeView(gmimaqCha1Data);
	gmimaqCha2TreeView = new mimaqTreeView(gmimaqCha2Data);
	gmimaqCha3TreeView = new mimaqTreeView(gmimaqCha3Data);
	
	//スーパーキャビテーション魚雷発射
	document.getElementById("mimaqTree").view = gmimaqTreeView;
	document.getElementById("mimaqCha1Tree").view = gmimaqCha1TreeView;
	document.getElementById("mimaqCha2Tree").view = gmimaqCha2TreeView;
	document.getElementById("mimaqCha3Tree").view = gmimaqCha3TreeView;
	mimaq.chainsert();
	mimaq.fileSaveItem();
	
	mimaqItemStore = null;
	mimaqItemStoreCha1 = null;
	mimaqItemStoreCha2 = null;
	mimaqItemStoreCha3 = null;
	
	//mimaqLimiterTimeStart = new Date();
	//window.alert(mimaqLimiterTimeStart);
}


function uninit() {
    document.getElementById("mimaqTree").view = null;
    document.getElementById("mimaqCha1Tree").view = null;
    document.getElementById("mimaqCha2Tree").view = null;
    document.getElementById("mimaqCha3Tree").view = null;
}

function mimaqTreeView(aData) {
    this._data = aData;
}

mimaqTreeView.prototype = {

    /**
     * nsITreeBoxObject
     */
    _treeBoxObject: null,
    _sorted: false,

    ////////////////////////////////////////////////////////////////
    // implements nsITreeView

    get rowCount() {
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties) {},
    getCellProperties: function(row, col, props) {
    
  	if(mimaqColorChange == 1){
  		var flag = 0;
  		for(i=0;i<50;i++){
  			if(col.index == i){
  				if(this._data[row][i] < 0){
  					flag = 1;
  				}else if(this._data[row][i] < 100 && this._data[row][i] > 0 && col.index == 10){
  					flag = 1;
  				}else if(this._data[row][i] < 100 && this._data[row][i] > 0 && col.index == 9){
  					flag = 1;
  				}
  			}
  		}
    	if(flag == 1){
    		var aserv=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
    		props.AppendElement(aserv.getAtom("makeItRed"));
    	}
    }

    },
    getColumnProperties: function(col, properties) {},
    isContainer: function(index) { return false; },
    isContainerOpen: function(index) { return false; },
    isContainerEmpty: function(index) { return false; },
    isSeparator: function(index) {
        return this._data[index][0] == null;
    },
    isSorted: function() { return false; },
    canDrop: function(targetIndex, orientation, dataTransfer) { return false; },
    drop: function(targetIndex, orientation, dataTransfer) {},
    getParentIndex: function(rowIndex) { return -1; },
    hasNextSibling: function(rowIndex, afterIndex) { return false; },
    getLevel: function(index) { return 0; },
    getImageSrc: function(row, col) {},
    getProgressMode: function(row, col) {},
    getCellValue: function(row, col) {},
    getCellText: function(row, col) {
        
        switch (col.index) {
            case 0: return this._data[row][0];
            case 1: return this._data[row][1];
            case 2: return this._data[row][2];
            case 3: return this._data[row][3];
            case 4: return this._data[row][4];
            case 5: return this._data[row][5];
            case 6: return this._data[row][6];
            case 7: return this._data[row][7];
            case 8: return this._data[row][8];
            case 9: return this._data[row][9];
            case 10: return this._data[row][10];
            case 11: return this._data[row][11];
            case 12: return this._data[row][12];
            case 13: return this._data[row][13];
            case 14: return this._data[row][14];
            case 15: return this._data[row][15];
            case 16: return this._data[row][16];
            case 17: return this._data[row][17];
            case 18: return this._data[row][18];
            case 19: return this._data[row][19];
            case 20: return this._data[row][20];
            //case 21: return this._data[row][21];
        }
        
    },
    setTree: function(tree) {
        if (tree) {
            // initialize view
            this._treeBoxObject = tree;
        }
        else {
            // finalize view
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index) {},
    cycleHeader: function(col) {
        // change sort direction
        /*
        var sortDir = col.element.getAttribute("sortDirection");
        switch (sortDir) {
            case "ascending" : sortDir = "descending"; break;
            case "descending": sortDir = "natural"   ; break;
            default          : sortDir = "ascending" ; break;
        }
        col.element.setAttribute("sortDirection", sortDir);
        // sort data
        this.sortItems(sortDir);
        this._sorted = (sortDir != "natural");
        */
        //buggggggggg
    },
    sortItems: function(aDirection) {
        // clone data to backup
        if (!this._originalData)
            this._originalData = this._data.concat();
        switch (aDirection) {
            case "ascending":
                this._data.sort();
                break;
            case "descending":
                this._data.sort();
                this._data.reverse();
                break;
            case "natural":
                // restore from original data
                this._data = this._originalData.concat();
                this._originalData = null;
                break;
        }
        // refresh tree
        this._treeBoxObject.invalidate();
    },
    isSorted: function() {
        return this._sorted;
    },
    selectionChanged: function() {},
    cycleCell: function(row, col) {},
    isEditable: function(row, col) { return false; },
    isSelectable: function(row, col) {},
    setCellValue: function(row, col, value) {},
    setCellText: function(row, col, value) {},
    performAction: function(action) {},
    performActionOnRow: function(action, row) {},
    performActionOnCell: function(action, row, col) {},

};

//var console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
//console.logStringMessage(test);
